var util = require('util'),
	EventEmitter = require('events').EventEmitter,
	utilFuncs = require('./util');
function SMSMessage(app, sid) {
	this._app = app;
	this._parent = app._account;
	this._client = app._client;
	this._cb = {}; //Indexed by callback ID
	this._cbID = 0;
	EventEmitter.call(this); //Make `this` a new EventEmitter
}
util.inherits(SMSMessage, EventEmitter); //Inherit all EventEmitter prototype methods
module.exports = SMSMessage;

SMSMessage.prototype._getResourceURI = function(type) {
	return this._parent._getResourceURI(type) + '/SMS/Messages/' + this.Sid;
}
SMSMessage.prototype.load = utilFuncs.globalLoad;
SMSMessage.prototype.reply = function(body, cb) {
	if(this.Direction != "incoming")
		throw new Error("You cannot reply to an outbound SMS Message.");
	this._app.sendSMS(this.To, this.From, body, cb);
}
